]> git.proxmox.com Git - mirror_ubuntu-jammy-kernel.git/blame - scripts/link-vmlinux.sh
Merge tag 'csky-for-linus-5.14-rc1' of git://github.com/c-sky/csky-linux
[mirror_ubuntu-jammy-kernel.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
d151e971
MY
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
11#
12# vmlinux
13# ^
14# |
d151e971
MY
15# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
1f2bfbd0 17# |
3a166fc2
NP
18# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
1f2bfbd0
SR
21# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
3ec8a5b3
MY
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
1f2bfbd0
SR
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41 if [ "${quiet}" != "silent_" ]; then
e83b9f55 42 printf " %-7s %s\n" "${1}" "${2}"
1f2bfbd0
SR
43 fi
44}
45
a8cccdd9
ST
46# Generate a linker script to ensure correct ordering of initcalls.
47gen_initcalls()
48{
49 info GEN .tmp_initcalls.lds
50
51 ${PYTHON} ${srctree}/scripts/jobserver-exec \
52 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
53 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
54 > .tmp_initcalls.lds
55}
56
38e89184
ST
57# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
58# .tmp_symversions.lds
59gen_symversions()
60{
61 info GEN .tmp_symversions.lds
62 rm -f .tmp_symversions.lds
63
64 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
65 if [ -f ${o}.symversions ]; then
66 cat ${o}.symversions >> .tmp_symversions.lds
67 fi
68 done
69}
70
1f2bfbd0
SR
71# Link of vmlinux.o used for section mismatch analysis
72# ${1} output file
73modpost_link()
74{
a5967db9 75 local objects
38e89184 76 local lds=""
a5967db9 77
6358d6e8 78 objects="--whole-archive \
d151e971 79 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
80 --no-whole-archive \
81 --start-group \
82 ${KBUILD_VMLINUX_LIBS} \
83 --end-group"
84
dc5723b0 85 if [ -n "${CONFIG_LTO_CLANG}" ]; then
a8cccdd9
ST
86 gen_initcalls
87 lds="-T .tmp_initcalls.lds"
88
38e89184
ST
89 if [ -n "${CONFIG_MODVERSIONS}" ]; then
90 gen_symversions
91 lds="${lds} -T .tmp_symversions.lds"
92 fi
93
dc5723b0
ST
94 # This might take a while, so indicate that we're doing
95 # an LTO link
96 info LTO ${1}
97 else
98 info LD ${1}
99 fi
100
38e89184 101 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
1f2bfbd0
SR
102}
103
6804c1af
PZ
104objtool_link()
105{
b1a1a1a0 106 local objtoolcmd;
6804c1af
PZ
107 local objtoolopt;
108
b1a1a1a0
ST
109 if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
110 # Don't perform vmlinux validation unless explicitly requested,
111 # but run objtool on vmlinux.o now that we have an object file.
112 if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
113 objtoolcmd="orc generate"
114 fi
115
116 objtoolopt="${objtoolopt} --duplicate"
117
118 if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
119 objtoolopt="${objtoolopt} --mcount"
120 fi
121 fi
122
6804c1af 123 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
b1a1a1a0
ST
124 objtoolopt="${objtoolopt} --noinstr"
125 fi
126
127 if [ -n "${objtoolopt}" ]; then
128 if [ -z "${objtoolcmd}" ]; then
129 objtoolcmd="check"
130 fi
131 objtoolopt="${objtoolopt} --vmlinux"
6804c1af
PZ
132 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
133 objtoolopt="${objtoolopt} --no-fp"
134 fi
b1a1a1a0 135 if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
6804c1af
PZ
136 objtoolopt="${objtoolopt} --no-unreachable"
137 fi
138 if [ -n "${CONFIG_RETPOLINE}" ]; then
139 objtoolopt="${objtoolopt} --retpoline"
140 fi
141 if [ -n "${CONFIG_X86_SMAP}" ]; then
142 objtoolopt="${objtoolopt} --uaccess"
143 fi
144 info OBJTOOL ${1}
b1a1a1a0 145 tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
6804c1af
PZ
146 fi
147}
148
1f2bfbd0 149# Link of vmlinux
341dfcf8 150# ${1} - output file
618916a4 151# ${2}, ${3}, ... - optional extra .o files
1f2bfbd0
SR
152vmlinux_link()
153{
154 local lds="${objtree}/${KBUILD_LDS}"
618916a4 155 local output=${1}
a5967db9 156 local objects
af73d78b 157 local strip_debug
5cc12472 158 local map_option
1f2bfbd0 159
d7b0827f
LT
160 info LD ${output}
161
618916a4
AN
162 # skip output file argument
163 shift
164
af73d78b
KC
165 # The kallsyms linking does not need debug symbols included.
166 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
167 strip_debug=-Wl,--strip-debug
168 fi
169
5cc12472
RV
170 if [ -n "${CONFIG_VMLINUX_MAP}" ]; then
171 map_option="-Map=${output}.map"
172 fi
173
1f2bfbd0 174 if [ "${SRCARCH}" != "um" ]; then
dc5723b0
ST
175 if [ -n "${CONFIG_LTO_CLANG}" ]; then
176 # Use vmlinux.o instead of performing the slow LTO
177 # link again.
178 objects="--whole-archive \
179 vmlinux.o \
180 --no-whole-archive \
181 ${@}"
182 else
183 objects="--whole-archive \
184 ${KBUILD_VMLINUX_OBJS} \
185 --no-whole-archive \
186 --start-group \
187 ${KBUILD_VMLINUX_LIBS} \
188 --end-group \
189 ${@}"
190 fi
a5967db9 191
618916a4 192 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
af73d78b 193 ${strip_debug#-Wl,} \
618916a4 194 -o ${output} \
5cc12472 195 ${map_option} \
a5967db9 196 -T ${lds} ${objects}
1f2bfbd0 197 else
6358d6e8 198 objects="-Wl,--whole-archive \
d151e971 199 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
200 -Wl,--no-whole-archive \
201 -Wl,--start-group \
202 ${KBUILD_VMLINUX_LIBS} \
203 -Wl,--end-group \
618916a4 204 ${@}"
a5967db9 205
618916a4 206 ${CC} ${CFLAGS_vmlinux} \
af73d78b 207 ${strip_debug} \
618916a4 208 -o ${output} \
5cc12472 209 ${map_option:+-Wl,${map_option}} \
6358d6e8
NP
210 -Wl,-T,${lds} \
211 ${objects} \
a5967db9 212 -lutil -lrt -lpthread
1f2bfbd0
SR
213 rm -f linux
214 fi
215}
216
e83b9f55 217# generate .BTF typeinfo from DWARF debuginfo
341dfcf8
AN
218# ${1} - vmlinux image
219# ${2} - file to dump raw BTF data into
e83b9f55
AN
220gen_btf()
221{
341dfcf8 222 local pahole_ver
db16c1fe 223 local extra_paholeopt=
e83b9f55 224
581b31c3 225 if ! [ -x "$(command -v ${PAHOLE})" ]; then
2a67a6cc 226 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
341dfcf8 227 return 1
581b31c3
AN
228 fi
229
e83b9f55 230 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
21a85bd6
LB
231 if [ "${pahole_ver}" -lt "116" ]; then
232 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
341dfcf8 233 return 1
e83b9f55
AN
234 fi
235
341dfcf8 236 vmlinux_link ${1}
af73d78b 237
a0b8200d
AN
238 if [ "${pahole_ver}" -ge "118" ] && [ "${pahole_ver}" -le "121" ]; then
239 # pahole 1.18 through 1.21 can't handle zero-sized per-CPU vars
240 extra_paholeopt="${extra_paholeopt} --skip_encoding_btf_vars"
241 fi
db16c1fe
IL
242 if [ "${pahole_ver}" -ge "121" ]; then
243 extra_paholeopt="${extra_paholeopt} --btf_gen_floats"
244 fi
245
af73d78b 246 info "BTF" ${2}
ff2e6efd 247 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${extra_paholeopt} ${1}
341dfcf8 248
90ceddcb
FS
249 # Create ${2} which contains just .BTF section but no symbols. Add
250 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
251 # deletes all symbols including __start_BTF and __stop_BTF, which will
252 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
253 # objcopy warnings: "empty loadable segment detected at ..."
254 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
255 --strip-all ${1} ${2} 2>/dev/null
256 # Change e_type to ET_REL so that it can be used to link final vmlinux.
257 # Unlike GNU ld, lld does not allow an ET_EXEC input.
258 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
e83b9f55 259}
1f2bfbd0 260
08beb669 261# Create ${2} .S file with all symbols from the ${1} object file
1f2bfbd0
SR
262kallsyms()
263{
1f2bfbd0
SR
264 local kallsymopt;
265
266 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 267 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
268 fi
269
4d5d5664 270 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
271 kallsymopt="${kallsymopt} --absolute-percpu"
272 fi
273
2213e9a6
AB
274 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
275 kallsymopt="${kallsymopt} --base-relative"
276 fi
277
08beb669
MY
278 info KSYMS ${2}
279 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
1f2bfbd0
SR
280}
281
8959e392
KC
282# Perform one step in kallsyms generation, including temporary linking of
283# vmlinux.
284kallsyms_step()
285{
286 kallsymso_prev=${kallsymso}
af73d78b
KC
287 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
288 kallsymso=${kallsyms_vmlinux}.o
08beb669 289 kallsyms_S=${kallsyms_vmlinux}.S
8959e392 290
d7b0827f 291 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
08beb669
MY
292 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
293
294 info AS ${kallsyms_S}
295 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
296 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
297 -c -o ${kallsymso} ${kallsyms_S}
8959e392
KC
298}
299
1f2bfbd0
SR
300# Create map file with all symbols from ${1}
301# See mksymap for additional details
302mksysmap()
303{
304 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
305}
306
10916706 307sorttable()
1347a2ce 308{
10916706 309 ${objtree}/scripts/sorttable ${1}
1347a2ce
LT
310}
311
1f2bfbd0 312# Delete output files in case of error
1f2bfbd0
SR
313cleanup()
314{
341dfcf8 315 rm -f .btf.*
1f2bfbd0 316 rm -f .tmp_System.map
a8cccdd9 317 rm -f .tmp_initcalls.lds
38e89184 318 rm -f .tmp_symversions.lds
1f2bfbd0
SR
319 rm -f .tmp_vmlinux*
320 rm -f System.map
321 rm -f vmlinux
5cc12472 322 rm -f vmlinux.map
1f2bfbd0 323 rm -f vmlinux.o
0b956e20 324 rm -f .vmlinux.d
1f2bfbd0
SR
325}
326
1f2bfbd0
SR
327# Use "make V=1" to debug this script
328case "${KBUILD_VERBOSE}" in
329*1*)
330 set -x
331 ;;
332esac
333
334if [ "$1" = "clean" ]; then
335 cleanup
336 exit 0
337fi
338
339# We need access to CONFIG_ symbols
94cf8acc 340. include/config/auto.conf
1f2bfbd0 341
1f2bfbd0
SR
342# Update version
343info GEN .version
278ae604
MY
344if [ -r .version ]; then
345 VERSION=$(expr 0$(cat .version) + 1)
346 echo $VERSION > .version
1f2bfbd0 347else
278ae604
MY
348 rm -f .version
349 echo 1 > .version
1f2bfbd0
SR
350fi;
351
352# final build of init/
083bc0e1 353${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
1f2bfbd0 354
abac4c89 355#link vmlinux.o
abac4c89 356modpost_link vmlinux.o
6804c1af 357objtool_link vmlinux.o
abac4c89
NP
358
359# modpost vmlinux.o to check for section mismatches
a721588d 360${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
abac4c89 361
898490c0
AG
362info MODINFO modules.builtin.modinfo
363${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
8b41fc44
MY
364info GEN modules.builtin
365# The second line aids cases where multiple modules share the same object.
366tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
367 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
898490c0 368
7fd78568 369btf_vmlinux_bin_o=""
341dfcf8 370if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
af73d78b
KC
371 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
372 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
da5fb182
SF
373 echo >&2 "Failed to generate BTF for vmlinux"
374 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
375 exit 1
341dfcf8
AN
376 fi
377fi
378
1f2bfbd0 379kallsymso=""
8959e392 380kallsymso_prev=""
1f2bfbd0
SR
381kallsyms_vmlinux=""
382if [ -n "${CONFIG_KALLSYMS}" ]; then
383
384 # kallsyms support
385 # Generate section listing all symbols and add it into vmlinux
386 # It's a three step process:
387 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
388 # but __kallsyms is empty.
389 # Running kallsyms on that gives us .tmp_kallsyms1.o with
390 # the right size
391 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
392 # the right size, but due to the added section, some
393 # addresses have shifted.
394 # From here, we generate a correct .tmp_kallsyms2.o
7e2b37c9
NP
395 # 3) That link may have expanded the kernel image enough that
396 # more linker branch stubs / trampolines had to be added, which
397 # introduces new names, which further expands kallsyms. Do another
398 # pass if that is the case. In theory it's possible this results
399 # in even more stubs, but unlikely.
400 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
401 # other bugs.
402 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
403 #
404 # a) Verify that the System.map from vmlinux matches the map from
405 # ${kallsymso}.
406
8959e392
KC
407 kallsyms_step 1
408 kallsyms_step 2
1f2bfbd0 409
7e2b37c9 410 # step 3
8959e392
KC
411 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
412 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
7e2b37c9
NP
413
414 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
8959e392 415 kallsyms_step 3
1f2bfbd0
SR
416 fi
417fi
418
d7b0827f 419vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
e83b9f55 420
c9a0f3b8 421# fill in BTF IDs
017dab34
JO
422if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
423 info BTFIDS vmlinux
424 ${RESOLVE_BTFIDS} vmlinux
c9a0f3b8
JO
425fi
426
10916706
SZ
427if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
428 info SORTTAB vmlinux
f14bf6a3
SZ
429 if ! sorttable vmlinux; then
430 echo >&2 Failed to sort kernel tables
431 exit 1
432 fi
1347a2ce
LT
433fi
434
1f2bfbd0
SR
435info SYSMAP System.map
436mksysmap vmlinux System.map
437
438# step a (see comment above)
439if [ -n "${CONFIG_KALLSYMS}" ]; then
440 mksysmap ${kallsyms_vmlinux} .tmp_System.map
441
442 if ! cmp -s System.map .tmp_System.map; then
5369f550 443 echo >&2 Inconsistent kallsyms data
367e43c5 444 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
445 exit 1
446 fi
447fi
0b956e20
RV
448
449# For fixdep
450echo "vmlinux: $0" > .vmlinux.d